
extern LCK **lck_tab;

extern ENTRY **buk_tab;

extern ENTRY **ent_tab;

extern long num_ents_ct;

extern int num_buks;

extern int blk_size;

extern unsigned char *empty_blk;

extern LCK *empty_blk_lck;

extern int cache_ent_enable;

SCM_EXPORT int ent_write P((ENTRY *ent));

extern int flush_ent_cntr;

extern LCK *flush_ent_lck;

SCM_EXPORT int ents_flush P((long trynum,long flushnum));

SCM_EXPORT int ent_flush_P P((ENTRY *tent));

SCM_EXPORT void release_ent P((ENTRY *ent,int acctype));

SCM_EXPORT int ent_update_access P((ENTRY *ent,int old_acctype,int new_acctype));

extern int free_buk_cntr;

extern LCK *free_ent_lck;

extern ENTRY *free_ents;

SCM_EXPORT ENTRY *get_free_free_ent P((void));

SCM_EXPORT void splice_out_ent P((int seg,long blk_num,ENTRY *buk,ENTRY *ent));

SCM_EXPORT void recycle_ent P((ENTRY *ent));

SCM_EXPORT ENTRY *select_idle_ent P((int lseg,long lblk_num));

SCM_EXPORT ENTRY *reclaim_ent P((ENTRY *ent,int lseg,long lblk_num));

SCM_EXPORT ENTRY *try_get_free_ent P((int lseg,long lblk_num));

SCM_EXPORT ENTRY *allocate_ent P((void));

SCM_EXPORT void ent_copy P((ENTRY *to_ent,ENTRY *from_ent));

SCM_EXPORT int get_ent_copy P((ENTRY *to_ent,int seg,long blk_num));

SCM_EXPORT int write_ent_copy P((ENTRY *ent));

SCM_EXPORT void flush_flc P((int seg,int fullness));

SCM_EXPORT int initload_flc_P P((int seg));

SCM_EXPORT int blk_free P((ENTRY *ent));

SCM_EXPORT int flc_fill P((int seg));

SCM_EXPORT int flc_proc P((unsigned char *keystr,int klen,unsigned char *vstr,int vlen,long *long_ara));

SCM_EXPORT ENTRY *create_new_blk_ent P((int seg));

SCM_EXPORT ENTRY *try_get_ent P((int seg,long blk_num,int acctype));

SCM_EXPORT ENTRY *chain_find_ent P((HAND *han,int acctype,unsigned char *key_str,int k_len,int *pkt));

SCM_EXPORT ENTRY *chain_find_prev_ent P((HAND *han,int acctype,unsigned char *key_str,int k_len,int *pkt));

SCM_EXPORT ENTRY *get_ent P((int seg,long blk_num,int acctype));

SCM_EXPORT ENTRY *switch_ent P((ENTRY *old_ent,int oldacc,long new_num,int newacc));

SCM_EXPORT int init_wb P((long max_num_ents_ct,int max_num_buks,int max_blk_size));

SCM_EXPORT int final_wb P((void));

SCM_EXPORT void check_blk P((unsigned char *blk));

SCM_EXPORT void check_key_order P((unsigned char *blk));

SCM_EXPORT int do_seg_buffers P((int seg,int_function func));

SCM_EXPORT int check_buffer P((ENTRY *ent));

SCM_EXPORT void check_access P((void));

SCM_EXPORT int flush_buffer P((ENTRY *ent));

SCM_EXPORT int purge_buffer P((ENTRY *ent));
